
// Procedure e funzioni: cenni alla ricorsione

import java.util.Scanner;

public class Esempio1 {

	// Una definizione ricorsiva del fattoriale
	static int fattoriale(int n) {
		if (n == 0) {
			return 1;
		} else {
			return n * fattoriale(n-1);
		}
	}
	
	static Scanner tastiera; 
	
	// Chiedi dei numeri all'utente e stampali.
	static void chiediEStampa() {
		System.out.println("Inserisci un numero (0 per finire)");
		int n = tastiera.nextInt();
		if (n != 0) {
			chiediEStampa();
			System.out.println("Hai inserito " + n);
		}
	}
	
	// Stampa una stringa, carattere per carattere.
	static void stampaString(String str, int posizione) {
		if (posizione >= str.length()) {
			return;  // Termina stampaString() qui.
		}
		// print è come pritnln ma non va a capo.
		System.out.print(str.charAt(posizione));   // (**)
		stampaString(str, posizione+1);            // (**)
	}
	
	
	public static void main(String[] args) {
		
		System.out.println(fattoriale(5));
		
		// Inizializziamo lo scanner per leggere da tastiera.
		// Questo basta farlo una volta sola per tutto il programma.
		tastiera = new Scanner(System.in);
		chiediEStampa();
		
		System.out.println("---------------------");
		String str = "etaoin shrdlu";
		stampaString(str, 0);
		System.out.println("");  // Vai a capo
		System.out.println("---------------------");
		
		// Esercizio 1.
		// Cosa succede se invertiamo l'ordine delle due righe
		// contrassegnate con (**) sopra?
		
		// Esercizio 2.
		// Provate a definire una funzione fib(n) che calcoli
		// l'ennesimo numero di Fibonacci in modo ricorsivo seguendo
		// la definizione della sequenza di Fibonacci.
		// Notate che al crescere di n, richiede molto tempo ad
		// essere calcolata, visto che di fatto vengono sommati
		// tanti numeri 1 fino a raggiungere il risultato.
		
		// Esercizio 3.
		// Si considerino le seguenti due operazioni sui numeri naturali:
		//   A) n -> 3*n+1   (con n qualunque) 
		//   B) n -> n/2     (consentita solo con n pari)
		// Dati tre numeri naturali (partenza, arrivo, passi), ci chiediamo
		// se esiste una sequenza di operazioni che, eseguite sul numero
		// "partenza" ci porti al numero "arrivo". La sequenza non deve 
		// essere più lunga di "passi" operazioni, e deve contenere
		// solo operazioni consentite.
		//
		// Si definisca una funzione
		//    static String strada(long partenza, long arrivo, int passi)
		// che restituisce la sequenza di operazioni che collega partenza
		// ad arrivo, o la stringa "X" se non è possibile raggiungerlo.
		//
		// Per esempio, strada(10,20,7) può dare "BABBAAB" perché:
		//           10
		//    --B--> 5
		//    --A--> 16
		//    --B--> 8
		//    --B--> 4
		//    --A--> 13
		//    --A--> 40
		//    --B--> 20
		// strada(10,20,6) invece dà "X".
	}

}
